Index: uspace/drv/usbkbd/kbddev.c
===================================================================
--- uspace/drv/usbkbd/kbddev.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/drv/usbkbd/kbddev.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -268,8 +268,4 @@
 static void usb_kbd_set_led(usb_kbd_t *kbd_dev) 
 {
-	if (kbd_dev->output_size == 0) {
-		return;
-	}
-
 	unsigned i = 0;
 	
@@ -548,5 +544,5 @@
  *                  according to HID Usage Tables.
  * @param count Number of key codes in report (size of the report).
- * @param report_id
+ * @param modifiers Bitmap of modifiers (Ctrl, Alt, Shift, GUI).
  * @param arg User-specified argument. Expects pointer to the keyboard device
  *            structure representing the keyboard.
@@ -555,5 +551,5 @@
  */
 static void usb_kbd_process_keycodes(const uint8_t *key_codes, size_t count,
-    uint8_t report_id, void *arg)
+    uint8_t modifiers, void *arg)
 {
 	if (arg == NULL) {
@@ -566,5 +562,5 @@
 	assert(kbd_dev != NULL);
 
-	usb_log_debug("Got keys from parser (report id: %d): %s\n", report_id, 
+	usb_log_debug("Got keys from parser (report id: %d): %s\n", modifiers, 
 	    usb_debug_str_buffer(key_codes, count, 0));
 	
@@ -767,7 +763,4 @@
 	usb_hid_report_path_t *path = usb_hid_report_path();
 	usb_hid_report_path_append_item(path, USB_HIDUT_PAGE_KEYBOARD, 0);
-	
-	usb_hid_report_path_set_report_id(path, 0);
-	
 	kbd_dev->key_count = usb_hid_report_input_length(
 	    kbd_dev->parser, path, USB_HID_PATH_COMPARE_END);
@@ -803,6 +796,5 @@
 	
 	kbd_dev->led_output_size = usb_hid_report_output_size(kbd_dev->parser, 
-	    kbd_dev->led_path, 
-	    USB_HID_PATH_COMPARE_END | USB_HID_PATH_COMPARE_USAGE_PAGE_ONLY);
+	    kbd_dev->led_path, USB_HID_PATH_COMPARE_END);
 	
 	usb_log_debug("Output report size (in items): %zu\n", 
Index: uspace/drv/usbkbd/main.c
===================================================================
--- uspace/drv/usbkbd/main.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/drv/usbkbd/main.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -33,5 +33,5 @@
 /**
  * @file
- * Main routines of USB KBD driver.
+ * Main routines of USB HID driver.
  */
 
@@ -42,5 +42,4 @@
 
 #include <usb/devdrv.h>
-#include <usb/devpoll.h>
 
 #include "kbddev.h"
@@ -76,5 +75,5 @@
  * @sa usb_kbd_fibril(), usb_kbd_repeat_fibril()
  */
-static int usb_kbd_try_add_device(usb_device_t *dev)
+static int usbhid_try_add_device(usb_device_t *dev)
 {
 	/* Create the function exposed under /dev/devices. */
@@ -106,5 +105,5 @@
 		usb_kbd_free(&kbd_dev);
 		return rc;
-	}
+	}	
 	
 	usb_log_debug("USB/HID KBD device structure initialized.\n");
@@ -196,20 +195,20 @@
  * @retval EREFUSED if the device is not supported.
  */
-static int usb_kbd_add_device(usb_device_t *dev)
+static int usbhid_add_device(usb_device_t *dev)
 {
-	usb_log_debug("usb_kbd_add_device()\n");
+	usb_log_debug("usbhid_add_device()\n");
 	
 	if (dev->interface_no < 0) {
 		usb_log_warning("Device is not a supported keyboard.\n");
-		usb_log_error("Failed to add USB KBD device: endpoint not "
-		    "found.\n");
+		usb_log_error("Failed to add HID device: endpoint not found."
+		    "\n");
 		return ENOTSUP;
 	}
 	
-	int rc = usb_kbd_try_add_device(dev);
+	int rc = usbhid_try_add_device(dev);
 	
 	if (rc != EOK) {
 		usb_log_warning("Device is not a supported keyboard.\n");
-		usb_log_error("Failed to add KBD device: %s.\n",
+		usb_log_error("Failed to add HID device: %s.\n",
 		    str_error(rc));
 		return rc;
@@ -225,13 +224,13 @@
 /* Currently, the framework supports only device adding. Once the framework
  * supports unplug, more callbacks will be added. */
-static usb_driver_ops_t usb_kbd_driver_ops = {
-        .add_device = usb_kbd_add_device,
+static usb_driver_ops_t usbhid_driver_ops = {
+        .add_device = usbhid_add_device,
 };
 
 
 /* The driver itself. */
-static usb_driver_t usb_kbd_driver = {
+static usb_driver_t usbhid_driver = {
         .name = NAME,
-        .ops = &usb_kbd_driver_ops,
+        .ops = &usbhid_driver_ops,
         .endpoints = usb_kbd_endpoints
 };
@@ -239,11 +238,24 @@
 /*----------------------------------------------------------------------------*/
 
+//static driver_ops_t kbd_driver_ops = {
+//	.add_device = usbhid_add_device,
+//};
+
+///*----------------------------------------------------------------------------*/
+
+//static driver_t kbd_driver = {
+//	.name = NAME,
+//	.driver_ops = &kbd_driver_ops
+//};
+
+/*----------------------------------------------------------------------------*/
+
 int main(int argc, char *argv[])
 {
-	printf(NAME ": HelenOS USB KBD driver.\n");
+	printf(NAME ": HelenOS USB HID driver.\n");
 
 	usb_log_enable(USB_LOG_LEVEL_DEBUG, NAME);
 
-	return usb_driver_main(&usb_kbd_driver);
+	return usb_driver_main(&usbhid_driver);
 }
 
Index: uspace/drv/usbkbd/usbkbd.ma
===================================================================
--- uspace/drv/usbkbd/usbkbd.ma	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/drv/usbkbd/usbkbd.ma	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -1,1 +1,2 @@
-10 usb&interface&class=HID&subclass=0x01&protocol=0x01
+100 usb&interface&class=HID&subclass=0x01&protocol=0x01
+10 usb&interface&class=HID
Index: uspace/drv/usbmid/main.c
===================================================================
--- uspace/drv/usbmid/main.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/drv/usbmid/main.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -55,7 +55,7 @@
 	int rc;
 
-	rc = usb_pipe_start_long_transfer(&dev->ctrl_pipe);
+	rc = usb_pipe_start_session(&dev->ctrl_pipe);
 	if (rc != EOK) {
-		usb_log_error("Failed to start transfer on control pipe: %s.\n",
+		usb_log_error("Failed to start session on control pipe: %s.\n",
 		    str_error(rc));
 		return rc;
@@ -64,5 +64,9 @@
 	bool accept = usbmid_explore_device(dev);
 
-	usb_pipe_end_long_transfer(&dev->ctrl_pipe);
+	rc = usb_pipe_end_session(&dev->ctrl_pipe);
+	if (rc != EOK) {
+		usb_log_warning("Failed to end session on control pipe: %s.\n",
+		    str_error(rc));
+	}
 
 	if (!accept) {
Index: uspace/drv/usbmouse/main.c
===================================================================
--- uspace/drv/usbmouse/main.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/drv/usbmouse/main.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -36,5 +36,4 @@
 #include "mouse.h"
 #include <usb/debug.h>
-#include <usb/devpoll.h>
 #include <errno.h>
 #include <str_error.h>
Index: uspace/drv/vhc/connhost.c
===================================================================
--- uspace/drv/vhc/connhost.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/drv/vhc/connhost.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -257,4 +257,5 @@
 
 static int interrupt_out(ddf_fun_t *fun, usb_target_t target,
+    size_t max_packet_size,
     void *data, size_t size,
     usbhc_iface_transfer_out_callback_t callback, void *arg)
@@ -266,4 +267,5 @@
 
 static int interrupt_in(ddf_fun_t *fun, usb_target_t target,
+    size_t max_packet_size,
     void *data, size_t size,
     usbhc_iface_transfer_in_callback_t callback, void *arg)
@@ -275,4 +277,5 @@
 
 static int control_write(ddf_fun_t *fun, usb_target_t target,
+    size_t max_packet_size,
     void *setup_packet, size_t setup_packet_size,
     void *data, size_t data_size,
@@ -292,4 +295,5 @@
 
 static int control_read(ddf_fun_t *fun, usb_target_t target,
+    size_t max_packet_size,
     void *setup_packet, size_t setup_packet_size,
     void *data, size_t data_size,
@@ -324,4 +328,16 @@
 }
 
+static int reserve_default_address(ddf_fun_t *fun, usb_speed_t ignored)
+{
+	usb_address_keeping_reserve_default(&addresses);
+	return EOK;
+}
+
+static int release_default_address(ddf_fun_t *fun)
+{
+	usb_address_keeping_release_default(&addresses);
+	return EOK;
+}
+
 static int request_address(ddf_fun_t *fun, usb_speed_t ignored,
     usb_address_t *address)
@@ -376,4 +392,6 @@
 
 usbhc_iface_t vhc_iface = {
+	.reserve_default_address = reserve_default_address,
+	.release_default_address = release_default_address,
 	.request_address = request_address,
 	.bind_address = bind_address,
Index: uspace/lib/c/arch/mips32/include/atomic.h
===================================================================
--- uspace/lib/c/arch/mips32/include/atomic.h	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/c/arch/mips32/include/atomic.h	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -70,4 +70,5 @@
 		"	sc %0, %1\n"
 		"	beq %0, %4, 1b\n"	/* if the atomic operation failed, try again */
+		/*	nop	*/		/* nop is inserted automatically by compiler */
 		"	nop\n"
 		: "=&r" (tmp),
Index: uspace/lib/c/generic/adt/measured_strings.c
===================================================================
--- uspace/lib/c/generic/adt/measured_strings.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/c/generic/adt/measured_strings.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -74,5 +74,5 @@
 	new->length = length;
 	new->value = ((uint8_t *) new) + sizeof(measured_string_t);
-	/* Append terminating zero explicitly - to be safe */
+	// append terminating zero explicitly - to be safe
 	memcpy(new->value, string, new->length);
 	new->value[new->length] = '\0';
Index: uspace/lib/c/generic/async.c
===================================================================
--- uspace/lib/c/generic/async.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/c/generic/async.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -1586,14 +1586,12 @@
  * @param dst     Address of the beginning of the destination buffer.
  * @param size    Size of the destination buffer.
- * @param flags   Flags to control the data transfer.
  *
  * @return Zero on success or a negative error code from errno.h.
  *
  */
-int
-async_data_read_start_generic(int phoneid, void *dst, size_t size, int flags)
-{
-	return async_req_3_0(phoneid, IPC_M_DATA_READ, (sysarg_t) dst,
-	    (sysarg_t) size, (sysarg_t) flags);
+int async_data_read_start(int phoneid, void *dst, size_t size)
+{
+	return async_req_2_0(phoneid, IPC_M_DATA_READ, (sysarg_t) dst,
+	    (sysarg_t) size);
 }
 
@@ -1685,15 +1683,12 @@
  * @param src     Address of the beginning of the source buffer.
  * @param size    Size of the source buffer.
- * @param flags   Flags to control the data transfer.
  *
  * @return Zero on success or a negative error code from errno.h.
  *
  */
-int
-async_data_write_start_generic(int phoneid, const void *src, size_t size,
-    int flags)
-{
-	return async_req_3_0(phoneid, IPC_M_DATA_WRITE, (sysarg_t) src,
-	    (sysarg_t) size, (sysarg_t) flags);
+int async_data_write_start(int phoneid, const void *src, size_t size)
+{
+	return async_req_2_0(phoneid, IPC_M_DATA_WRITE, (sysarg_t) src,
+	    (sysarg_t) size);
 }
 
Index: uspace/lib/c/generic/vfs/vfs.c
===================================================================
--- uspace/lib/c/generic/vfs/vfs.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/c/generic/vfs/vfs.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -378,6 +378,5 @@
 	
 	req = async_send_1(vfs_phone, VFS_IN_READ, fildes, &answer);
-	rc = async_data_read_start_generic(vfs_phone, (void *) buf, nbyte,
-	    IPC_XF_RESTRICT);
+	rc = async_data_read_start(vfs_phone, (void *)buf, nbyte);
 	if (rc != EOK) {
 		vfs_exchange_end(vfs_phone);
@@ -408,6 +407,5 @@
 	
 	req = async_send_1(vfs_phone, VFS_IN_WRITE, fildes, &answer);
-	rc = async_data_write_start_generic(vfs_phone, (void *) buf, nbyte,
-	    IPC_XF_RESTRICT);
+	rc = async_data_write_start(vfs_phone, (void *)buf, nbyte);
 	if (rc != EOK) {
 		vfs_exchange_end(vfs_phone);
Index: uspace/lib/c/include/async.h
===================================================================
--- uspace/lib/c/include/async.h	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/c/include/async.h	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -341,8 +341,5 @@
 
 extern aid_t async_data_read(int, void *, size_t, ipc_call_t *);
-#define async_data_read_start(p, buf, len) \
-	async_data_read_start_generic((p), (buf), (len), IPC_XF_NONE)
-
-extern int async_data_read_start_generic(int, void *, size_t, int);
+extern int async_data_read_start(int, void *, size_t);
 extern bool async_data_read_receive(ipc_callid_t *, size_t *);
 extern int async_data_read_finalize(ipc_callid_t, const void *, size_t);
@@ -383,8 +380,5 @@
 	    (arg4), (answer))
 
-#define async_data_write_start(p, buf, len) \
-	async_data_write_start_generic((p), (buf), (len), IPC_XF_NONE)
-
-extern int async_data_write_start_generic(int, const void *, size_t, int);
+extern int async_data_write_start(int, const void *, size_t);
 extern bool async_data_write_receive(ipc_callid_t *, size_t *);
 extern int async_data_write_finalize(ipc_callid_t, void *, size_t);
Index: uspace/lib/c/include/ipc/dev_iface.h
===================================================================
--- uspace/lib/c/include/ipc/dev_iface.h	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/c/include/ipc/dev_iface.h	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -45,6 +45,4 @@
 	/** Interface provided by USB host controller. */
 	USBHC_DEV_IFACE,
-	/** Interface provided by USB HID devices. */
-	USBHID_DEV_IFACE,
 
 	DEV_IFACE_MAX
Index: uspace/lib/drv/generic/dev_iface.c
===================================================================
--- uspace/lib/drv/generic/dev_iface.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/drv/generic/dev_iface.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -43,5 +43,4 @@
 #include "remote_usb.h"
 #include "remote_usbhc.h"
-#include "remote_usbhid.h"
 #include "remote_pci.h"
 
@@ -52,6 +51,5 @@
 		&remote_pci_iface,
 		&remote_usb_iface,
-		&remote_usbhc_iface,
-		&remote_usbhid_iface
+		&remote_usbhc_iface
 	}
 };
Index: uspace/lib/drv/generic/driver.c
===================================================================
--- uspace/lib/drv/generic/driver.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/drv/generic/driver.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -47,5 +47,4 @@
 #include <stdlib.h>
 #include <str.h>
-#include <str_error.h>
 #include <ctype.h>
 #include <errno.h>
@@ -403,5 +402,5 @@
 			    get_remote_method(rem_iface, iface_method_idx);
 			if (iface_method_ptr == NULL) {
-				/* The interface has not such method */
+				// the interface has not such method
 				printf("%s: driver_connection_gen error - "
 				    "invalid interface method.", driver->name);
@@ -656,6 +655,4 @@
 int ddf_driver_main(driver_t *drv)
 {
-	int rc;
-
 	/*
 	 * Remember the driver structure - driver_ops will be called by generic
@@ -671,21 +668,9 @@
 	
 	/*
-	 * Register driver with device manager using generic handler for
-	 * incoming connections.
+	 * Register driver by device manager with generic handler for incoming
+	 * connections.
 	 */
-	rc = devman_driver_register(driver->name, driver_connection);
-	if (rc != EOK) {
-		printf("Error: Failed to register driver with device manager "
-		    "(%s).\n", (rc == EEXISTS) ? "driver already started" :
-		    str_error(rc));
-		
-		return 1;
-	}
-	
-	/* Return success from the task since server has started. */
-	rc = task_retval(0);
-	if (rc != EOK)
-		return 1;
-
+	devman_driver_register(driver->name, driver_connection);
+	
 	async_manager();
 	
Index: uspace/lib/drv/generic/remote_usbhc.c
===================================================================
--- uspace/lib/drv/generic/remote_usbhc.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/drv/generic/remote_usbhc.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -50,4 +50,6 @@
 static void remote_usbhc_control_write(ddf_fun_t *, void *, ipc_callid_t, ipc_call_t *);
 static void remote_usbhc_control_read(ddf_fun_t *, void *, ipc_callid_t, ipc_call_t *);
+static void remote_usbhc_reserve_default_address(ddf_fun_t *, void *, ipc_callid_t, ipc_call_t *);
+static void remote_usbhc_release_default_address(ddf_fun_t *, void *, ipc_callid_t, ipc_call_t *);
 static void remote_usbhc_request_address(ddf_fun_t *, void *, ipc_callid_t, ipc_call_t *);
 static void remote_usbhc_bind_address(ddf_fun_t *, void *, ipc_callid_t, ipc_call_t *);
@@ -59,4 +61,7 @@
 /** Remote USB host controller interface operations. */
 static remote_iface_func_ptr_t remote_usbhc_iface_ops [] = {
+	remote_usbhc_reserve_default_address,
+	remote_usbhc_release_default_address,
+
 	remote_usbhc_request_address,
 	remote_usbhc_bind_address,
@@ -124,4 +129,36 @@
 }
 
+void remote_usbhc_reserve_default_address(ddf_fun_t *fun, void *iface,
+    ipc_callid_t callid, ipc_call_t *call)
+{
+	usbhc_iface_t *usb_iface = (usbhc_iface_t *) iface;
+
+	if (!usb_iface->reserve_default_address) {
+		async_answer_0(callid, ENOTSUP);
+		return;
+	}
+	
+	usb_speed_t speed = DEV_IPC_GET_ARG1(*call);
+	
+	int rc = usb_iface->reserve_default_address(fun, speed);
+
+	async_answer_0(callid, rc);
+}
+
+void remote_usbhc_release_default_address(ddf_fun_t *fun, void *iface,
+    ipc_callid_t callid, ipc_call_t *call)
+{
+	usbhc_iface_t *usb_iface = (usbhc_iface_t *) iface;
+
+	if (!usb_iface->release_default_address) {
+		async_answer_0(callid, ENOTSUP);
+		return;
+	}
+
+	int rc = usb_iface->release_default_address(fun);
+
+	async_answer_0(callid, rc);
+}
+
 void remote_usbhc_request_address(ddf_fun_t *fun, void *iface,
     ipc_callid_t callid, ipc_call_t *call)
@@ -233,4 +270,5 @@
 	}
 
+	size_t max_packet_size = DEV_IPC_GET_ARG3(*call);
 	usb_target_t target = {
 		.address = DEV_IPC_GET_ARG1(*call),
@@ -262,5 +300,5 @@
 	trans->size = len;
 
-	rc = transfer_func(fun, target,
+	rc = transfer_func(fun, target, max_packet_size,
 	    buffer, len,
 	    callback_out, trans);
@@ -288,4 +326,5 @@
 	}
 
+	size_t max_packet_size = DEV_IPC_GET_ARG3(*call);
 	usb_target_t target = {
 		.address = DEV_IPC_GET_ARG1(*call),
@@ -309,5 +348,5 @@
 	trans->size = len;
 
-	int rc = transfer_func(fun, target,
+	int rc = transfer_func(fun, target, max_packet_size,
 	    trans->buffer, len,
 	    callback_in, trans);
@@ -375,4 +414,5 @@
 	};
 	size_t data_buffer_len = DEV_IPC_GET_ARG3(*call);
+	size_t max_packet_size = DEV_IPC_GET_ARG4(*call);
 
 	int rc;
@@ -410,5 +450,5 @@
 	trans->size = data_buffer_len;
 
-	rc = usb_iface->control_write(fun, target,
+	rc = usb_iface->control_write(fun, target, max_packet_size,
 	    setup_packet, setup_packet_len,
 	    data_buffer, data_buffer_len,
@@ -437,4 +477,5 @@
 		.endpoint = DEV_IPC_GET_ARG2(*call)
 	};
+	size_t max_packet_size = DEV_IPC_GET_ARG3(*call);
 
 	int rc;
@@ -474,5 +515,5 @@
 	}
 
-	rc = usb_iface->control_read(fun, target,
+	rc = usb_iface->control_read(fun, target, max_packet_size,
 	    setup_packet, setup_packet_len,
 	    trans->buffer, trans->size,
@@ -496,32 +537,21 @@
 	}
 
-#define _INIT_FROM_HIGH_DATA2(type, var, arg_no) \
-	type var = (type) DEV_IPC_GET_ARG##arg_no(*call) / (1 << 16)
-#define _INIT_FROM_LOW_DATA2(type, var, arg_no) \
-	type var = (type) DEV_IPC_GET_ARG##arg_no(*call) % (1 << 16)
-#define _INIT_FROM_HIGH_DATA3(type, var, arg_no) \
-	type var = (type) DEV_IPC_GET_ARG##arg_no(*call) / (1 << 16)
-#define _INIT_FROM_MIDDLE_DATA3(type, var, arg_no) \
-	type var = (type) (DEV_IPC_GET_ARG##arg_no(*call) / (1 << 8)) % (1 << 8)
-#define _INIT_FROM_LOW_DATA3(type, var, arg_no) \
-	type var = (type) DEV_IPC_GET_ARG##arg_no(*call) % (1 << 8)
-
-	_INIT_FROM_HIGH_DATA2(usb_address_t, address, 1);
-	_INIT_FROM_LOW_DATA2(usb_endpoint_t, endpoint, 1);
-
-	_INIT_FROM_HIGH_DATA3(usb_speed_t, speed, 2);
-	_INIT_FROM_MIDDLE_DATA3(usb_transfer_type_t, transfer_type, 2);
-	_INIT_FROM_LOW_DATA3(usb_direction_t, direction, 2);
-
-	_INIT_FROM_HIGH_DATA2(size_t, max_packet_size, 3);
-	_INIT_FROM_LOW_DATA2(unsigned int, interval, 3);
-
-#undef _INIT_FROM_HIGH_DATA2
-#undef _INIT_FROM_LOW_DATA2
-#undef _INIT_FROM_HIGH_DATA3
-#undef _INIT_FROM_MIDDLE_DATA3
-#undef _INIT_FROM_LOW_DATA3
-
-	int rc = usb_iface->register_endpoint(fun, address, speed, endpoint,
+#define INIT_FROM_HIGH_DATA(type, var, arg_no) \
+	type var = (type) DEV_IPC_GET_ARG##arg_no(*call) / 256
+#define INIT_FROM_LOW_DATA(type, var, arg_no) \
+	type var = (type) DEV_IPC_GET_ARG##arg_no(*call) % 256
+
+	INIT_FROM_HIGH_DATA(usb_address_t, address, 1);
+	INIT_FROM_LOW_DATA(usb_endpoint_t, endpoint, 1);
+	INIT_FROM_HIGH_DATA(usb_transfer_type_t, transfer_type, 2);
+	INIT_FROM_LOW_DATA(usb_direction_t, direction, 2);
+
+#undef INIT_FROM_HIGH_DATA
+#undef INIT_FROM_LOW_DATA
+
+	size_t max_packet_size = (size_t) DEV_IPC_GET_ARG3(*call);
+	unsigned int interval  = (unsigned int) DEV_IPC_GET_ARG4(*call);
+
+	int rc = usb_iface->register_endpoint(fun, address, endpoint,
 	    transfer_type, direction, max_packet_size, interval);
 
Index: uspace/lib/drv/include/usbhc_iface.h
===================================================================
--- uspace/lib/drv/include/usbhc_iface.h	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/drv/include/usbhc_iface.h	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -66,4 +66,5 @@
  *   - argument #1 is target address
  *   - argument #2 is target endpoint
+ *   - argument #3 is max packet size of the endpoint
  * - this call is immediately followed by IPC data read (async version)
  * - the call is not answered until the device returns some data (or until
@@ -84,4 +85,19 @@
  */
 typedef enum {
+	/** Reserve usage of default address.
+	 * This call informs the host controller that the caller will be
+	 * using default USB address. It is duty of the HC driver to ensure
+	 * that only single entity will have it reserved.
+	 * The address is returned via IPC_M_USBHC_RELEASE_DEFAULT_ADDRESS.
+	 * The caller can start using the address after receiving EOK
+	 * answer.
+	 */
+	IPC_M_USBHC_RESERVE_DEFAULT_ADDRESS,
+
+	/** Release usage of default address.
+	 * @see IPC_M_USBHC_RESERVE_DEFAULT_ADDRESS
+	 */
+	IPC_M_USBHC_RELEASE_DEFAULT_ADDRESS,
+
 	/** Asks for address assignment by host controller.
 	 * Answer:
@@ -153,12 +169,9 @@
 	/** Register endpoint attributes at host controller.
 	 * This is used to reserve portion of USB bandwidth.
-	 * When speed is invalid, speed of the device is used.
 	 * Parameters:
-	 * - USB address + endpoint number
-	 *   - packed as ADDR << 16 + EP
-	 * - speed + transfer type + direction
-	 *   - packed as ( SPEED << 8 + TYPE ) << 8 + DIR
-	 * - maximum packet size + interval (in milliseconds)
-	 *   - packed as MPS << 16 + INT
+	 * - USB address + endpoint number (ADDR * 256 + EP)
+	 * - transfer type + direction (TYPE * 256 + DIR)
+	 * - maximum packet size
+	 * - interval (in milliseconds)
 	 * Answer:
 	 * - EOK - reservation successful
@@ -189,5 +202,5 @@
 
 /** Out transfer processing function prototype. */
-typedef int (*usbhc_iface_transfer_out_t)(ddf_fun_t *, usb_target_t,
+typedef int (*usbhc_iface_transfer_out_t)(ddf_fun_t *, usb_target_t, size_t,
     void *, size_t,
     usbhc_iface_transfer_out_callback_t, void *);
@@ -197,5 +210,5 @@
 
 /** In transfer processing function prototype. */
-typedef int (*usbhc_iface_transfer_in_t)(ddf_fun_t *, usb_target_t,
+typedef int (*usbhc_iface_transfer_in_t)(ddf_fun_t *, usb_target_t, size_t,
     void *, size_t,
     usbhc_iface_transfer_in_callback_t, void *);
@@ -209,6 +222,5 @@
 	int (*release_address)(ddf_fun_t *, usb_address_t);
 
-	int (*register_endpoint)(ddf_fun_t *,
-	    usb_address_t, usb_speed_t, usb_endpoint_t,
+	int (*register_endpoint)(ddf_fun_t *, usb_address_t, usb_endpoint_t,
 	    usb_transfer_type_t, usb_direction_t, size_t, unsigned int);
 	int (*unregister_endpoint)(ddf_fun_t *, usb_address_t, usb_endpoint_t,
@@ -222,8 +234,10 @@
 
 	int (*control_write)(ddf_fun_t *, usb_target_t,
+	    size_t,
 	    void *, size_t, void *, size_t,
 	    usbhc_iface_transfer_out_callback_t, void *);
 
 	int (*control_read)(ddf_fun_t *, usb_target_t,
+	    size_t,
 	    void *, size_t, void *, size_t,
 	    usbhc_iface_transfer_in_callback_t, void *);
Index: uspace/lib/net/generic/generic.c
===================================================================
--- uspace/lib/net/generic/generic.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/net/generic/generic.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -106,5 +106,5 @@
 		return EBADMEM;
 
-	/* Request the address */
+	// request the address
 	message_id = async_send_1(phone, (sysarg_t) message,
 	    (sysarg_t) device_id, NULL);
@@ -112,7 +112,7 @@
 	async_wait_for(message_id, &result);
 
-	/* If not successful */
+	// if not successful
 	if ((string == EOK) && (result != EOK)) {
-		/* Clear the data */
+		// clear the data
 		free(*address);
 		free(*data);
@@ -242,5 +242,5 @@
 		return EBADMEM;
 
-	/* Request the translation */
+	// request the translation
 	message_id = async_send_3(phone, (sysarg_t) message,
 	    (sysarg_t) device_id, (sysarg_t) count, (sysarg_t) service, NULL);
@@ -249,7 +249,7 @@
 	async_wait_for(message_id, &result);
 
-	/* If not successful */
+	// if not successful
 	if ((string == EOK) && (result != EOK)) {
-		/* Clear the data */
+		// clear the data
 		free(*translation);
 		free(*data);
Index: uspace/lib/net/generic/net_checksum.c
===================================================================
--- uspace/lib/net/generic/net_checksum.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/net/generic/net_checksum.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -52,5 +52,5 @@
 uint16_t compact_checksum(uint32_t sum)
 {
-	/* Shorten to the 16 bits */
+	// shorten to the 16 bits
 	while (sum >> 16)
 		sum = (sum & 0xffff) + (sum >> 16);
@@ -72,9 +72,9 @@
 	size_t index;
 
-	/* Sum all the 16 bit fields */
+	// sum all the 16 bit fields
 	for (index = 0; index + 1 < length; index += 2)
 		seed += (data[index] << 8) + data[index + 1];
 
-	/* Last odd byte with zero padding */
+	// last odd byte with zero padding
 	if (index + 1 == length)
 		seed += data[index] << 8;
@@ -94,39 +94,39 @@
 	size_t index;
 
-	/* Process full bytes */
+	// process full bytes
 	while (length >= 8) {
-		/* Add the data */
+		// add the data
 		seed ^= (*data) << 24;
 		
-		/* For each added bit */
+		// for each added bit
 		for (index = 0; index < 8; ++index) {
-			/* If the first bit is set */
+			// if the first bit is set
 			if (seed & 0x80000000) {
-				/* Shift and divide the checksum */
+				// shift and divide the checksum
 				seed = (seed << 1) ^ ((uint32_t) CRC_DIVIDER_BE);
 			} else {
-				/* Shift otherwise */
+				// shift otherwise
 				seed <<= 1;
 			}
 		}
 		
-		/* Move to the next byte */
+		// move to the next byte
 		++data;
 		length -= 8;
 	}
 
-	/* Process the odd bits */
+	// process the odd bits
 	if (length > 0) {
-		/* Add the data with zero padding */
+		// add the data with zero padding
 		seed ^= ((*data) & (0xff << (8 - length))) << 24;
 		
-		/* For each added bit */
+		// for each added bit
 		for (index = 0; index < length; ++index) {
-			/* If the first bit is set */
+			// if the first bit is set
 			if (seed & 0x80000000) {
-				/* Shift and divide the checksum */
+				// shift and divide the checksum
 				seed = (seed << 1) ^ ((uint32_t) CRC_DIVIDER_BE);
 			} else {
-				/* Shift otherwise */
+				// shift otherwise
 				seed <<= 1;
 			}
@@ -148,38 +148,38 @@
 	size_t index;
 
-	/* Process full bytes */
+	// process full bytes
 	while (length >= 8) {
-		/* Add the data */
+		// add the data
 		seed ^= (*data);
 		
-		/* For each added bit */
+		// for each added bit
 		for (index = 0; index < 8; ++index) {
-			/* If the last bit is set */
+			// if the last bit is set
 			if (seed & 1) {
-				/* Shift and divide the checksum */
+				// shift and divide the checksum
 				seed = (seed >> 1) ^ ((uint32_t) CRC_DIVIDER_LE);
 			} else {
-				/* Shift otherwise */
+				// shift otherwise
 				seed >>= 1;
 			}
 		}
 		
-		/* Move to the next byte */
+		// move to the next byte
 		++data;
 		length -= 8;
 	}
 
-	/* Process the odd bits */
+	// process the odd bits
 	if (length > 0) {
-		/* Add the data with zero padding */
+		// add the data with zero padding
 		seed ^= (*data) >> (8 - length);
 		
 		for (index = 0; index < length; ++index) {
-			/* If the last bit is set */
+			// if the last bit is set
 			if (seed & 1) {
-				/* Shift and divide the checksum */
+				// shift and divide the checksum
 				seed = (seed >> 1) ^ ((uint32_t) CRC_DIVIDER_LE);
 			} else {
-				/* Shift otherwise */
+				// shift otherwise
 				seed >>= 1;
 			}
@@ -198,5 +198,5 @@
 uint16_t flip_checksum(uint16_t checksum)
 {
-	/* Flip, zero is returned as 0xFFFF (not flipped) */
+	// flip, zero is returned as 0xFFFF (not flipped)
 	checksum = ~checksum;
 	return checksum ? checksum : IP_CHECKSUM_ZERO;
@@ -216,5 +216,5 @@
 uint16_t ip_checksum(uint8_t *data, size_t length)
 {
-	/* Compute, compact and flip the data checksum */
+	// compute, compact and flip the data checksum
 	return flip_checksum(compact_checksum(compute_checksum(0, data,
 	    length)));
Index: uspace/lib/net/generic/packet_client.c
===================================================================
--- uspace/lib/net/generic/packet_client.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/net/generic/packet_client.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -267,5 +267,5 @@
 		return NULL;
 
-	/* Get a new packet */
+	// get a new packet
 	copy = packet_get_4_remote(phone, PACKET_DATA_LENGTH(packet),
 	    PACKET_MAX_ADDRESS_LENGTH(packet), packet->max_prefix,
@@ -274,10 +274,10 @@
 		return NULL;
 
-	/* Get addresses */
+	// get addresses
 	addrlen = packet_get_addr(packet, &src, &dest);
-	/* Copy data */
+	// copy data
 	if ((packet_copy_data(copy, packet_get_data(packet),
 	    PACKET_DATA_LENGTH(packet)) == EOK) &&
-	    /* Copy addresses if present */
+	    // copy addresses if present
 	    ((addrlen <= 0) ||
 	    (packet_set_addr(copy, src, dest, addrlen) == EOK))) {
Index: uspace/lib/net/il/ip_client.c
===================================================================
--- uspace/lib/net/il/ip_client.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/net/il/ip_client.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -124,6 +124,5 @@
 
 	// TODO IPv6
-#if 0
-	case AF_INET6:
+/*	case AF_INET6:
 		if (addrlen != sizeof(struct sockaddr_in6))
 			return EINVAL;
@@ -131,5 +130,5 @@
 		address_in6 = (struct sockaddr_in6 *) addr;
 		return EOK;
-#endif
+*/
 
 	default:
@@ -160,8 +159,6 @@
 	size_t padding;
 
-	/*
-	 * Compute the padding if IP options are set
-	 * multiple of 4 bytes
-	 */
+	// compute the padding if IP options are set
+	// multiple of 4 bytes
 	padding =  ipopt_length % 4;
 	if (padding) {
@@ -170,14 +167,14 @@
 	}
 
-	/* Prefix the header */
+	// prefix the header
 	data = (uint8_t *) packet_prefix(packet, sizeof(ip_header_t) + padding);
 	if (!data)
 		return ENOMEM;
 
-	/* Add the padding */
+	// add the padding
 	while (padding--)
 		data[sizeof(ip_header_t) + padding] = IPOPT_NOOP;
 
-	/* Set the header */
+	// set the header
 	header = (ip_header_t *) data;
 	header->header_length = IP_COMPUTE_HEADER_LENGTH(sizeof(ip_header_t) +
Index: uspace/lib/net/tl/icmp_client.c
===================================================================
--- uspace/lib/net/tl/icmp_client.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/net/tl/icmp_client.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -81,5 +81,5 @@
 		*mtu = header->un.frag.mtu;
 
-	/* Remove debug dump */
+	// remove debug dump
 #ifdef CONFIG_DEBUG
 	printf("ICMP error %d (%d) in packet %d\n", header->type, header->code,
